img_key    = image.load("res/key.png")
img_keyMed    = image.load("res/keyMed.png")
img_keyBig    = image.load("res/keyBig.png")
img_keySpace    = image.load("res/keySpace.png")

abcKeyboard = {
"1","2","3","4","5","6","7","8","9","0","_nl",
"q","w","e","r","t","y","u","i","o","p","_nl",
"a","s","d","f","g","h","j","k","l","-","_nl",
"_mABC","z","x","c","v","b","n","m","_m<-","_nl",
"_b#&*","_s","_bok" }

ABCKeyboard = {
"1","2","3","4","5","6","7","8","9","0","_nl",
"Q","W","E","R","T","Y","U","I","O","P","_nl",
"A","S","D","F","G","H","J","K","L","-","_nl",
"_mabc","Z","X","C","V","B","N","M","_m<-","_nl",
"_b#&*","_s","_bok" }

SymbKeyboard = {
"1","2","3","4","5","6","7","8","9","0","_nl",
"!","@","#","$","%","^","&","*","(",")","_nl",
"<",">","?",";","\"","_","+","~","[","]","_nl",
"_mABC","=","/",":","'","-",",",".","_m<-","_nl",
"_babc","_s","_bok" }

function KeysIterator(keys,cb)
	local x,y	
	x=16
	y=64
	for i in ipairs(keys) do
		if keys[i]=="_nl" then
			y=y+35
			x=16
		elseif string.sub(keys[i],1,2)=="_m" then
			cb(string.sub(keys[i],3,string.len(keys[i])),img_keyMed,x,y,52)
			x=x+53
		elseif string.sub(keys[i],1,2)=="_b" then
			cb(string.sub(keys[i],3,string.len(keys[i])),img_keyBig,x,y,69)
			x=x+70
		elseif string.sub(keys[i],1,2)=="_s" then
			cb(" ",img_keySpace,x,y,209)
			x=x+210
		else
			cb(keys[i],img_key,x,y,34)
			x=x+35
		end
	end
end

function Input(title)
	local ScreenOr,ScreenW,ScreenH,keyboard,inp,focused,focusedTyp,focusedX,focusedY,focusedW,done,tColor,BcgColor
	tColor=color.new(0,0,0)
	BcgColor=color.new(255,255,255)
	ScreenOr=screen.orientation()
	screen.orientation(0)
	ScreenW =screen.width()
	ScreenH =screen.height()
	inp          =""
	focused  =nil
	done=false
	keyboard=abcKeyboard
	
	text.size   (20)
	text.color(tColor)
	function redraw()
		screen.fillrect(0,0,ScreenW,ScreenH,BcgColor)
		text.size   (18)
		text.draw(16,0,title)
		text.size   (20)
		text.draw(16,22,inp.."_","center",ScreenW-16)
		
		KeysIterator(keyboard,function (key,imgType,x,y,width)
													if focused~=nil and key==focused then
														focusedTyp=imgType
														focusedX   =x
														focusedY   =y
														focusedW  =width
													else
														imgType:draw(x,y)
														text.draw(x,y+5,key,"center",x+width)
													end
							end )
		if focused~=nil then
			focusedTyp:draw(focusedX-8,focusedY-8,focusedW+16,50)
			text.draw(focusedX+3,focusedY+8,focused,"center",focusedX+focusedW)
			screen.update()
			os.sleep(30)
			focused=nil
			redraw()
			return
		end
		screen.update()
	end
	redraw()
	
	local xt,yt
	while 1 do
		if control.read()==1 then
			if control.isTouch()==1 and touch.click()==1 then
					xt,yt=touch.pos()
					KeysIterator(keyboard,function (key,imgType,x,y,width)
						if xt>=x and yt>=y and xt<=x+width and yt<=y+25 then
							if key=="<-" then
								if string.len(inp)>0 then inp=string.sub(inp,1,string.len(inp)-1) end
							elseif key=="ABC" then
								keyboard=ABCKeyboard
								redraw()
								return
							elseif key=="abc" then
								keyboard=abcKeyboard
								redraw()
								return
							elseif key=="#&*" then
								keyboard=SymbKeyboard
								redraw()
								return
							elseif key=="ok" then done=true 
							else
								inp=inp..key
							end
							focused=key
							redraw()
						end
					end)
				end
		elseif control.isButton()==1 and button.click() == 1  then break
		else
			if done==true then break end
			os.sleep(5)
		end
	end
	
	screen.orientation(ScreenOr)
	return inp
end
