--Eread v0.95 developed for Zen X-Fi2 by Breakb
--Copyright(c) 2010

--Current Book file
File=nil
FileOffset=0

--default data
fontSize  =18
fontColor=color.new(0,0,0)
fontTitleColor=color.new(172,32,0)
bcgColor=color.new(255,255,255)
ScreenOrientation=0
currentBook=0
bookList={}

--data file
function SaveData()
	local dfile,i
	dfile=io.open("data.dat","w")
	dfile:write("fontSize=",fontSize,";ScreenOrientation=",ScreenOrientation,";currentBook=",currentBook,";")
	dfile:write("fontColor=color.new(",color.r(fontColor),",",color.g(fontColor),",",color.b(fontColor),");bcgColor=color.new(",color.r(bcgColor),",",color.g(bcgColor),",",color.b(bcgColor),")\10")
	i=1
	while i<table.getn(bookList) do
		dfile:write(bookList[i],"\1",bookList[i+1],"\1",table.concat(bookList[i+2],"\2"),"\2\1",table.concat(bookList[i+3],"\2"),"\2\1\10")
		i=i+4
	end
	dfile:close()
end
function LoadData()
	local dfile,i,firstLine,str,lst
	dfile=io.open("data.dat","r")
	if(dfile==nil) then MessageDialog("Data file doesn't exist.. reseting data file!",true);SaveData();return end --corrupted data file
	firstLine=true
	for line in dfile:lines() do
		if(firstLine==true) then 
			loadstring(line)()
			firstLine=false
		else
			str,lst=line:match("([^\1]+)\1()"); 
			table.insert(bookList,table.getn(bookList)+1,str)--name
			str,lst=line:match("([^\1]+)\1()",lst);
			table.insert(bookList,table.getn(bookList)+1,tonumber(str))--current offset
			str,lst=line:match("([^\1]+)\1()",lst);
			table.insert(bookList,table.getn(bookList)+1,{})--bookmarks
			for bk,ps in str:gmatch("([^\2]+)\2([^\2]+)\2") do table.insert(bookList[table.getn(bookList)],table.getn(bookList[table.getn(bookList)])+1,bk);table.insert(bookList[table.getn(bookList)],table.getn(bookList[table.getn(bookList)])+1,tonumber(ps)) end
			str=line:match("([^\1]+)\1",lst);
			table.insert(bookList,table.getn(bookList)+1,{})--contents
			for bk,ps in str:gmatch("([^\2]+)\2([^\2]+)\2") do table.insert(bookList[table.getn(bookList)],table.getn(bookList[table.getn(bookList)])+1,bk);table.insert(bookList[table.getn(bookList)],table.getn(bookList[table.getn(bookList)])+1,tonumber(ps)) end
		end
	end
	dfile:close()
end

--library
function AddBook(name)
	if io.open(name)==nil then MessageDialog("The file "..name.." doesnt exist!",true) return false end --book doesnt exist
	currentBook=table.getn(bookList)+1 --current book
	table.insert(bookList,table.getn(bookList)+1,name) --name
	table.insert(bookList,table.getn(bookList)+1,0)		--current offset
	table.insert(bookList,table.getn(bookList)+1,{})		--no of bookmarks
	table.insert(bookList,table.getn(bookList)+1,{})		--content
	LoadBook()
	GetBookContents()
	SaveData()
end
function OpenBook(index)
	if index==nil or index==0 then return end
	currentBook=index;LoadBook();SaveData()
end
function RemoveBook(index)
	if index==nil or index==0 then return end
	--print("deleting",index,bookList[index])
	table.remove(bookList,index)--name
	table.remove(bookList,index)--current offset
	table.remove(bookList,index)--no of bookmarks
	table.remove(bookList,index)--content
	if currentBook==index then CloseBook();currentBook=0 
	elseif currentBook>index then currentBook=currentBook-4 end --!! this is important
	SaveData()
end
function RefreshBook(index)
	if index==nil or index==0 then return end
	--reload contents
	currentBook=index
	LoadBook()
	GetBookContents()
	SaveData()
end
function LoadBook()
	CloseBook()
	if currentBook==0 then return end
	File       =io.open(bookList[currentBook])
	if File==nil then MessageDialog("The file "..bookList[currentBook].." doesnt exist!\nIt will be removed from library",true);RemoveBook(currentBook);return end
	--UTF8 bom?
	if File:read(3) == string.char(239,187,191) then FileOffset=3
	else FileOffset=0 end
end
function CloseBook()
	if File~=nil then File:close();File=nil; end
end
function BookPercentage()
	if File==nil then return "" end
	return string.format ("%d%%",bookList[currentBook+1]/File:seek("end")*100)
end

--contents
function GetBookContents()--scan text file for possible content lines like chapter X etc
	MessageDialog("Building contents table..\nPlease wait..")
	bookList[currentBook+3]={}
	File:seek("set",FileOffset)
	local empty,contents,contentsOffset,prevOffset,content;
	empty=false;contents=false;prevOffset=0
	for line in File:lines() do 
		if line=="\13" or line=="" then 
			if contents==true and content:len()<20 then content=string.gsub(content,"[\13\10]","");table.insert(bookList[currentBook+3],table.getn(bookList[currentBook+3])+1,content);table.insert(bookList[currentBook+3],table.getn(bookList[currentBook+3])+1,contentsOffset);contents=false--;print("   contents",content,contentsOffset);
			else empty=true end
		elseif empty==true then contents=true;content=line;contentsOffset=prevOffset;empty=false; 
		else contents=false; end
		prevOffset=File:seek("cur")-FileOffset
	end
end
function GotoContent(id)
	if File==nil or id==nil or id==0 then return end
	bookList[currentBook+1]=bookList[currentBook+3][id+1]
	SaveData()
end

--bookmarking
function GotoBookmark(id)
	if File==nil or id==nil or id==0 then return end
	bookList[currentBook+1]=bookList[currentBook+2][id+1]
	SaveData()
	DrawLines()
end
function AddBookmark(name)
	if File==nil then return end
	table.insert(bookList[currentBook+2],table.getn(bookList[currentBook+2])+1,name) --name
	table.insert(bookList[currentBook+2],table.getn(bookList[currentBook+2])+1,bookList[currentBook+1])--offset
	SaveData()
end
function RemoveBookmark(id)
	if File==nil or id==nil or id==0 then return end
	table.remove(bookList[currentBook+2],id)--name
	table.remove(bookList[currentBook+2],id)--offset
	SaveData()
end

--navigation
function PrevPage()
	if File==nil then return end
	--TXT files
	local bufferSize=math.min(2048,bookList[currentBook+1])
	if bufferSize==0 then return end
	local bufferStart=bookList[currentBook+1]-bufferSize
	local lineTable={}
	local prevLineEnd=1
	File:seek("set",FileOffset+bufferStart)
	local buffer=File:read(bufferSize)
	text.size   (fontSize)
	TextFormatter(bufferStart,buffer,
			function(lineStart,lineEnd,x,lineHeight)
				table.insert(lineTable,1,lineHeight)
				table.insert(lineTable,1,prevLineEnd)
				prevLineEnd=lineEnd
	end )
	local y,i;y=0;i=1
	while 1 do
		bookList[currentBook+1]=bufferStart+lineTable[i]-1
		y=y+lineTable[i+1];i=i+2
		if i>table.getn(lineTable) then break end
		if y>(ScreenHeight-fontSize) then break end
	end
	SaveData()
	DrawLines()
end
function PrevLine()
	if File==nil then return end
	--TXT files
	local bufferSize=math.min(2048,bookList[currentBook+1])
	if bufferSize==0 then return end
	local bufferStart=bookList[currentBook+1]-bufferSize
	local line,prevLineEnd;prevLineEnd=1;line=1
	File:seek("set",FileOffset+bufferStart)
	local buffer=File:read(bufferSize)
	text.size   (fontSize)
	TextFormatter(bufferStart,buffer,
			function(lineStart,lineEnd,x,lineHeight)
				line=prevLineEnd;prevLineEnd=lineEnd
	end )
	bookList[currentBook+1]=bufferStart+line-1
	SaveData()
	DrawLines()	
end
function NextPage() 
	if File==nil then return end
	if nextPageOffset>=(File:seek("end")-FileOffset) then return end
	if nextPageOffset==bookList[currentBook+1] then return end
	bookList[currentBook+1]=nextPageOffset
	SaveData()
	DrawLines()
end
function NextLine()
	if File==nil then return end
	if nextLineOffset>=(File:seek("end")-FileOffset) then return end
	if nextLineOffset==bookList[currentBook+1] then return end
	bookList[currentBook+1]=nextLineOffset
	SaveData()
	DrawLines()
end
function FirstPage()
	if File==nil then return end
	bookList[currentBook+1]=0
	SaveData()
end
function LastPage()
	if File==nil then return end
	bookList[currentBook+1]=File:seek("end")-FileOffset
	PrevPage()
end


function isContentLine(pos)
	local i=2
	while i<=table.getn(bookList[currentBook+3]) do
		if bookList[currentBook+3][i]==pos then return true end i=i+2
	end
	return false
end
--Formats raw text into lines
function TextFormatter(bufferOffset,buffer,callback)
	local x,y,wordWidth,xOffset,wordLineOffset,wordLastEndOffset;y=0
	if bufferOffset==0 then xOffset=24 else xOffset=0 end;x=xOffset --if beggining of the file start as new line
	--#####################################
	--## Split buffer in to lines and lines into words
	--#####################################
		for newlineSymbs,lineRelOffset,line,lineRelOffsetEnd in buffer:gmatch("([\13\10]*)()([^\13\10]+)()") do --get lines from buffer
			if newlineSymbs:len()>0 then xOffset=24;x=24 end
			--is this a content line?
			if isContentLine(bufferOffset+lineRelOffset-1)==true then
				if callback(lineRelOffset,lineRelOffsetEnd,xOffset,fontSize*2)==true then return end
				--if not then word wrap the line
			else wordLineOffset=1
					for wordRelOffset,word,wordRelOffsetEnd in line:gmatch("()([%s]*[^%s]+)()") do
							
							wordWidth=text.draw(0,-100,word,"left",0,2)
							if x+wordWidth>ScreenWidth and x~=0 and x~=24 then --new screen line
								if callback(lineRelOffset+wordLineOffset-1,lineRelOffset+wordRelOffset-1,xOffset,fontSize)==true then return end
								xOffset=0;x=0;wordLineOffset=wordRelOffset
							end
							x=x+wordWidth;wordLastEndOffset=wordRelOffsetEnd
						end
						if callback(lineRelOffset+wordLineOffset-1,lineRelOffsetEnd,xOffset,fontSize)==true then return end
			end	
			xOffset=24;x=24
		end
end

--some variables set as result of draw function
FirstVisibleLine=""
nextPageOffset=0
nextLineOffset=0
function DrawLines()
	--prepare screen
	screen.fillrect(0,0,ScreenWidth,ScreenHeight,bcgColor)
	text.size(fontSize)
	text.color(fontColor)
	if File==nil then text.draw(0,ScreenHeight/2-fontSize,"No book opened..","center",ScreenWidth,2);text.draw(0,ScreenHeight/2,"Please choose a book from the library.","center",ScreenWidth,2);screen.update() return end
	--TXT file
	local y,prevLineEnd
	y=0;nextLineOffset=0;prevLineEnd=1
	File:seek("set",FileOffset+bookList[currentBook+1])
	local buffer=File:read(4096)
	TextFormatter(bookList[currentBook+1],buffer,
			function(lineStart,lineEnd,x,lineHeight)
				--check if line fits onto the screen
				if (y+lineHeight)>ScreenHeight then nextPageOffset=bookList[currentBook+1]+prevLineEnd-1; return true end 
				if lineHeight==fontSize then text.draw(x,y,buffer:sub(lineStart,lineEnd),"left",0,2) else
					--content line
					text.color(fontTitleColor);text.size(fontSize+2);text.draw(0,y+fontSize/2,buffer:sub(lineStart,lineEnd),"center",ScreenWidth,2);text.color(fontColor);text.size(fontSize);
				end
				if nextLineOffset==0 then FirstVisibleLine=buffer:sub(lineStart,lineEnd);nextLineOffset=bookList[currentBook+1]+lineEnd-1 end
				y=y+lineHeight;prevLineEnd=lineEnd
	end )
	screen.update()
end

dofile("gui.lua")  --import "gui"
-- Main(){
--dofile("data.lua")--load data
ScreenWidth =screen.width()
ScreenHeight=screen.height()
LoadData()
local oldOrientation=screen.orientation()
screen.orientation(ScreenOrientation)
ScreenWidth =screen.width()
ScreenHeight=screen.height()
LoadBook()
DrawLines()
local SwipeX,SwipeY,CurX,CurY,moving
moving=0
while 1 do--main event loop
	if control.read()==1 then
		if control.isTouch()==1 then
			if touch.click()==1 		then CurX,CurY=touch.pos();if(CurX>(ScreenWidth/2)) then NextPage() else PrevPage() end
			elseif touch.move()==1 then	if moving==0 then 
																		SwipeX,SwipeY = touch.pos()
																		moving=1
																	else 
																		CurX,CurY=touch.pos()
																		if math.abs(SwipeY-CurY)>fontSize*2 then	
																			CurX=math.ceil((SwipeY-CurY)/(fontSize*4))
																			if CurX>0 then NextLine() else PrevLine() end
																			SwipeY=CurY
																		end
																end
			elseif touch.up()==1  	then	moving=0 end
		elseif control.isButton()==1 then
			if button.click() == 1		then	if button.home()==1 then
																	NextPage()
																else
																	if MainMenu()==true then break end;DrawLines()
																end
			elseif button.hold()==1 then	if MainMenu()==true then break end;DrawLines() end
		end    
	else
		os.sleep(5)
	end
end
CloseBook()
screen.orientation(oldOrientation)
--}

